﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Threading;

namespace SL4StringFormatExample
{
    public class DateHolder : INotifyPropertyChanged
    {
        public DateHolder() {
            this.CurrentDateTime = DateTime.Now;
            DispatcherTimer updateTime = new DispatcherTimer();
            updateTime.Interval = new TimeSpan(0, 0, 0, 0, 100);
            updateTime.Tick += new EventHandler(updateTime_Tick);
            updateTime.Start();
        }

        void updateTime_Tick(object sender, EventArgs e)
        {
            this.CurrentDateTime = DateTime.Now;
        }
        #region INotifyPropertyChanged values

        public event PropertyChangedEventHandler PropertyChanged;

				protected void RaisePropertyChanged(string propertyName)
				{
					var handler = PropertyChanged;
					if(handler != null)
					{
						handler(this, new PropertyChangedEventArgs(propertyName));
					}
				}        
        #endregion

        #region CurrentDateTime (INotifyPropertyChanged Property)
        private DateTime _currentDateTime;

        public DateTime CurrentDateTime
        {
            get { return _currentDateTime; }
            set
            {
                _currentDateTime = value;
                RaisePropertyChanged("CurrentDateTime");
            }
        }
        #endregion
    }
}
